SuperStrict


Include "data/collide.bmx"

AppTitle $="OGG Player"
Graphics 256,164


Const versoin	:String		= "0.1 BETA"

Global settings	:TStream	
Global musicdir	:Int

Global imgLogo	:TImage		= LoadImage("data/gfx/logo 1.png")
Global imgOpen 	:TImage 		= LoadImage("data/gfx/open.png")

Global imgBG		:TImage		= LoadImage("data/gfx/background.png")
Global imgArrow	:TImage		= LoadAnimImage("data/gfx/arrows.png",10,5,0,2)
Global imgBar		:TImage		= LoadImage("data/gfx/vol_bar.png")
Global imgSlider	:TImage		= LoadAnimImage("data/gfx/vol_slider.png",12,12,0,2)
	Global imgSoundOFF	:TImage 	= LoadImage("data/gfx/soundoff.png")
	Global sliderX	:Int		= 51
	Global slider2X	:Int 	= 100
	Const  SliderVal	:Float	= Float(192 / 10)

Global imgPlay	:TImage		= LoadAnimImage("data/gfx/play.png",64,32,0,2)
Global imgBreak	:TImage		= LoadAnimImage("data/gfx/break.png",64,32,0,2)
Global imgStop	:TImage		= LoadAnimImage("data/gfx/stop.png",64,32,0,2)
Global imgMFW		:TImage		= LoadAnimImage("data/gfx/move_fw.png",64,32,0,2)
Global imgMBW		:TImage		= LoadAnimImage("data/gfx/move_bw.png",64,32,0,2)

Global pan_enabled		:Int		= 0

Global music		:TMusic[501]
Global currentMusic:Int		= 0
Global count		:Int

Global globalChannel:TChannel = AllocChannel()

Global sec:TTimer = CreateTimer(1)

For Local a:Int = 0 To 500
	music:TMusic[a] = New TMusic
	music[a].volume = 51
	music[a].pan = 0
Next



'START SCREEN
For Local a:Int = 0 To 42
SetClsColor a,a,a
Cls
	DrawImage imgLogo ,GraphicsWidth()/2 - 25,64
Flip
Next

'LOAD MUSIC (nicht fertig^^)

loadmusic()


'MAINLOOP

SetBlend(alphablend)
SetClsColor 42,42,42

Repeat
Cls


	setChannelActions()
	drawInterface()
	drawPlaylist()


Flip
Until AppTerminate()

Function DrawInterface()

	If Not MouseDown(1) Then FlushMouse()

	If HotSpotCollide(MouseX(),MouseY(),32,116,200,12) And MouseDown(1) Then
		sliderX = MouseX() - 6
		setSoundVolume()
		music[currentmusic].volume = sliderX
	EndIf
	If sliderX =< 32 Then 
		sliderX = 32
		DrawImage imgSoundOFF,5,118
		SetChannelVolume music[currentmusic].channel,0
	ElseIf sliderX > 212 Then
		sliderX = 212
	EndIf
	
	DrawImage imgBG,0,0
	DrawImage imgBar,0,122
	DrawImage imgSlider,sliderX,116,HotSpotCollide(MouseX(),MouseY(),sliderX,116,12,12)
	'DrawImage imgopen,5,4
	If pan_enabled = 1 Then DrawImage imgSlider,music[currentmusic].pan,116,HotSpotCollide(MouseX(),MouseY(),slider2X,116,12,12)
	
	DrawImage imgMBW,0,132,	HotSpotCollide	(MouseX(),MouseY(),0,132,64,32)
	DrawImage imgStop,64,132,	HotSpotCollide	(MouseX(),MouseY(),64,132,64,32)
	DrawImage imgPlay,128,132,	HotSpotCollide	(MouseX(),MouseY(),128,132,64,32)
	DrawImage imgMFW,192,132,	HotSpotCollide	(MouseX(),MouseY(),192,132,64,32)
EndFunction

Function setSoundVolume()
	Print Float((sliderX - 32)/sliderVal) + "|" + sliderX
	SetChannelVolume music[currentmusic].channel,Float((sliderX - 32)/sliderVal)
EndFunction

Function setChannelActions()

If MouseY() > 100 And music[currentmusic].music <> Null Then

	If HotSpotCollide(MouseX(),MouseY(),128,132,64,32) And MouseHit(1) And Not ChannelPlaying(music[currentmusic].channel) Then 
		music[currentmusic].channel = CueSound(music[currentmusic].music)
		ResumeChannel music[currentmusic].channel
	FlushMouse()
	ElseIf HotSpotCollide(MouseX(),MouseY(),128,132,64,32) And MouseHit(1) And ChannelPlaying(music[currentmusic].channel) Then 
		PauseChannel music[currentmusic].channel
	FlushMouse()
	EndIf
	If HotSpotCollide(MouseX(),MouseY(),64,132,64,32)  And ChannelPlaying(music[currentmusic].channel) And MouseHit(1) Then 
		StopChannel(music[currentmusic].channel) 
		music[currentmusic].channel = CueSound (music[currentmusic].music) 
	FlushMouse()
	EndIf
	If ChannelPlaying(music[currentmusic].channel) Then
		If HotSpotCollide	(MouseX(),MouseY(),0,132,64,32) And MouseDown(1) Then 
			SetChannelRate music[currentmusic].channel,-2
	
		ElseIf HotSpotCollide	(MouseX(),MouseY(),192,132,64,32) And MouseDown(1) Then
			SetChannelRate music[currentmusic].channel,3
	
		Else
			SetChannelRate music[currentmusic].channel,1
		EndIf
	EndIf	
EndIf

	If  HotSpotCollide(MouseX(),MouseY(),30,20,14,8) And currentmusic > 0 And MouseHit(1) Then 
		currentmusic:- 1
		sliderX = music[currentmusic].volume
		Print currentmusic
	FlushMouse()
	EndIf
	If  HotSpotCollide(MouseX(),MouseY(),30,88,14,8) And currentmusic < 120 And MouseHit(1) Then 
		currentmusic:+ 1
		sliderX = music[currentmusic].volume
		Print currentmusic
	FlushMouse()
	EndIf
	
EndFunction

Function LoadMusic()	

	musicdir = ReadDir("music")
	
		For Local a:Int = 0 To 500
			Local file:String = NextFile(musicdir)
		Print a
			
			If file = Null Then Exit
			If file = "." Or file = ".." Then Continue
			If file$ <> "" Then
			music[a-2].music = LoadSound("music/"+file$)
			If Not music[a-2].music Then RuntimeError "unable to load music" + file$
				music[a-2].path = "music/"+file$
				music[a-2].name = String(Left(file$,file.length - 4))
				music[a-2].channel = CueSound(music[currentmusic].music)
				music[a-2].pan = 0
				music[a-2].volume = 51
				music[a-2].rate = 1			
			EndIf
		Next
		'ready to player
EndFunction

Function DrawPlaylist()

	SetColor 115,160,116
	For Local a:Int = -2 To 2
		If a = -2 Then 
			SetAlpha .15
		ElseIf a = -1 Then 
			SetAlpha .5
		ElseIf a = 0 Then 
			SetAlpha 1
		ElseIf a = 1 Then 
			SetAlpha .5
		ElseIf a = 2 Then 
			SetAlpha .15
		EndIf
		 
			If a + currentmusic < 0 Then 
				DrawText currentmusic + a + " -",32,52 + a* 12
			ElseIf a = 0 And music[currentmusic +a].name <> "" Then
				DrawText currentmusic + a + " " + music[currentmusic + a].name,32,52 + a* 12
			ElseIf a >= 0 And music[currentmusic + a].name = "" Then 
				DrawText currentmusic + a + " -",32,52 + a* 12
			ElseIf a >= 0 And music[currentmusic +a].name <> "" Then 
				DrawText currentmusic + a + " " + music[currentmusic + a].name,32,52 + a* 12
			Else
				DrawText currentmusic + a + " "+ music[currentmusic + a].name,32,52 + a* 12
			EndIf
		Next
	
	SetAlpha 1
	SetColor 255,255,255
	
	DrawImage imgarrow,32,22,0 
	DrawImage imgarrow,32,90,1

EndFunction

Type TMusic 

	Field music:TSound
	Field path:String
	Field name:String
	Field channel:TChannel
	Field volume:Int
	Field pan:Int
	Field rate:Int
	
EndType